local addonName, addon = ...

addon.version = GetAddOnMetadata(addonName, 'Version')
addon.language = {}
setmetatable(addon.language, {__index = function(_, k) return k end})

addon.config = {
	version = 1.5,
	channel = "say",
	petID = "BattlePet-0-000004F956ED",
	inviteMsg = "123",
	autoSell = true,
	announce = true,
	solo = { ownInterrupt = 'self', ownDispel = 'self', ownStolen = 'self', ownReflect = 'self', ownAD = 'self',otherInterrupt = 'self', otherDispel = 'self', otherStolen = 'self', otherReflect = 'self', otherAD = 'self' },
	instance = { ownInterrupt = 'self', ownDispel = 'self', ownStolen = 'self', ownReflect = 'self', ownAD = 'self',otherInterrupt = 'self', otherDispel = 'self', otherStolen = 'self', otherReflect = 'self', otherAD = 'self' },
	party = { ownInterrupt = 'self', ownDispel = 'self', ownStolen = 'self', ownReflect = 'self', ownAD = 'self',otherInterrupt = 'self', otherDispel = 'self', otherStolen = 'self', otherReflect = 'self', otherAD = 'self' },
	raid = { ownInterrupt = 'self', ownDispel = 'self', ownStolen = 'self', ownReflect = 'self', ownAD = 'self',otherInterrupt = 'self', otherDispel = 'self', otherStolen = 'self', otherReflect = 'self', otherAD = 'self' },
	soundOwn = '',
	soundOther = ''
}

addon.frame = CreateFrame('Frame', addonName .. 'Frame')
addon.frame:Hide()
addon.panel = CreateFrame('Frame', addonName .. 'Panel')
addon.panel:Hide()
addon.scrollFrame = CreateFrame("ScrollFrame", nil, UIParent, "UIPanelScrollFrameTemplate")
addon.scrollFrame:Hide()

addon.avoidableDamage = {
	cache = {},
	saveByName = {},
	saveBySpell = {},
	sum = {},
	list = {},
	alist = {},
	timer = {},
	spells = {
		-- 木桩测试
		[167381] = true,		--- 傀儡重击
		[167385] = true,		--- 超强打击
		-- 词缀
		[209862] = true,		--- 火山
		[226512] = true,		--- 鲜血脓液
		[296142] = true,		--- 暗影碎击
		[288858] = true,		--- 驱逐灵魂
		-- 自由镇
		[257274] = true,		--- 污秽油膜
		[272046] = true,		--- 俯冲轰炸
		[258352] = true,		--- 葡萄弹
		[272374] = true,		--- 回旋利刃
		[256594] = true,		--- 砸桶
		[278467] = true,		--- 腐蚀的自由镇啤酒
		[256546] = true,		--- 狂鲨飓风
--		[256477] = true,		--- 鲨鱼投掷
		[256552] = true,		--- 扭动的鲨鱼
		[256706] = true,		--- 重新武装
		[257902] = true,		--- 弹跳龟壳
		[257310] = true,		--- 火炮弹幕
		[257308] = true,		--- 燃烧弹片
		[257460] = true,		--- 燃烧残片
		[258199] = true,		--- 碎地
		[276061] = true,		--- 投掷巨石
		[258779] = true,		--- 海流喷射
		[274400] = true,		--- 决斗冲刺
		[257426] = true,		--- 反手猛击
		[274389] = true,		--- 捕鼠陷阱
		[274516] = true,		--- 光滑泡沫
		-- 风暴祭坛
		[264560] = true,		--- 窒息海潮
		[267899] = true,		--- 妨害劈砍
		[269104] = true,		--- 爆炸虚空
		[267385] = true,		--- 触须猛击
		[268280] = true,		--- 潮汐之荚
		[276286] = true,		--- 切割旋风
		[276292] = true,		--- 旋转猛击
		-- 围攻伯拉勒斯
		[257348] = true,		--- 肉钩
		[273681] = true,		--- 重击者
		[257326] = true,		--- 血腥冲撞
		[257585] = true,		--- 火炮弹幕
		[257292] = true,		--- 沉重挥砍
		[257288] = true,		--- 沉重挥砍
		[268260] = true,		--- 舷侧攻击
		[269029] = true,		--- 清扫甲板
		[268443] = true,		--- 恐惧箭雨
		[261563] = true,		--- 毁灭之潮
		[276068] = true,		--- 海潮涌动
		[257886] = true,		--- 盐水池
		[275051] = true,		--- 腐败之水
		[270185] = true,		--- 深渊的呼唤
		[269266] = true,		--- 猛击
		[272546] = true,		--- 香蕉狂怒
		[274941] = true,		--- 香蕉狂怒
		[272874] = true,		--- 践踏
		[256660] = true,		--- 燃烧沥青
		[256663] = true,		--- 燃烧沥青
		[275775] = true,		--- 狂野风暴
		[272426] = true,		--- 瞄准火炮
		[272711] = true,		--- 碾压重击
		[256627] = true,		--- 抽脸者
		-- 托尔达戈
		[257119] = true,		--- 流沙陷阱
		[257785] = true,		--- 闪光飞刃
		[256710] = true,		--- 燃烧的军火库
		[256976] = true,		--- 点火
		[256955] = true,		--- 炉渣之焰
		[256083] = true,		--- 交叉点火
		[263345] = true,		--- 巨力冲击
		[258634] = true,		--- 爆燃
		[259711] = true,		--- 全面禁闭
		-- 维克雷斯庄园
		[260570] = true,		--- 野火
		[260569] = true,		--- 野火
		[264923] = true,		--- 暴捶
		[264712] = true,		--- 腐物喷发
		[268234] = true,		--- 胆汁爆炸
		[268387] = true,		--- 传染性残渣
		[268308] = true,		--- 不协乐段
		[264531] = true,		--- 破片陷阱
		[265407] = true,		--- 用餐时间
		[264150] = true,		--- 击碎
		-- 阿塔达萨
		[250585] = true, 		--- 剧毒之池
		[250259] = true,		--- 剧毒跳碾
		[250022] = true,		--- 沙德拉的回响
		[250036] = true,		--- 暗影残留物
		[253666] = true,		--- 烈焰之箭
		[257692] = true,		--- 蒂基之焰
		[255620] = true,		--- 脓疮爆发
		-- 诸王之眠
		[265914] = true,		--- 溶化的黄金
		[266191] = true,		--- 回旋飞斧
		[368419] = true,		--- 强风劈砍
		[270289] = true,		--- 净化光线
		[270503] = true,		--- 狩猎跃击
		[271564] = true,		--- 防腐液
		[267639] = true,		--- 燃烧腐蚀
		[270931] = true,		--- 黑暗射击
		-- 暴富矿区!
		[257337] = true,		--- 电击之爪
		[275907] = true,		--- 地质冲击
		[259533] = true,		--- 艾泽里特催化剂
		[260103] = true,		--- 推进器冲击
		[276234] = true, 		--- 微型飞弹
		[260279] = true,		--- 加特林机枪
		[270277] = true,		--- 大型红色按钮
		[262811] = true,		--- 吸血球
		[268702] = true,		--- 狂怒地震
		[269313] = true,		--- 终极冲击
		[268846] = true,		--- 回声之刃
		[268865] = true,		--- 立场大炮
		[262287] = true,		--- 震荡榴弹
		[262348] = true,		--- 地雷爆炸
		[257371] = true,		--- 催泪瓦斯
		[268365] = true,		--- 采掘炸药
		[271432] = true,		--- 测试飞弹
		[269092] = true,		--- 炮弹弹幕
		-- 塞塔里斯神庙
		[268851] = true,		--- 闪电之盾
		[263371] = true,		--- 导电
		[263573] = true,		--- 飓风打击
		[263424] = true,		--- 电弧冲刺
		[263927] = true,		--- 剧毒之池
		[272699] = true,		--- 毒性喷吐
		[264206] = true,		--- 钻地
		[264574] = true,		--- 劲射
		[272657] = true,		--- 毒性吐息
		[273995] = true,		--- 火油冲击
		[273225] = true,		--- 乱射
		[272696] = true,		--- 瓶中闪电
		[267483] = true,		--- 不羁的火花
		[272655] = true,		--- 黄沙冲刷
		-- 地渊孢林
		[260894] = true,		--- 蔓延腐化
		[264757] = true,		--- 喋血盛宴
		[260312] = true,		--- 冲锋
		[260793] = true,		--- 消化不良
		[259720] = true,		--- 颠覆
		[265542] = true,		--- 腐化胆汁
		[265540] = true,		--- 腐化胆汁
		[272609] = true,		--- 疯狂凝视
		[272469] = true,		--- 深渊猛击
		[265019] = true,		--- 狂野顺劈斩
		[265665] = true,		--- 污秽淤泥？
		[265511] = true,		--- 灵魂抽取

	},
	spellsNoTank = {
		-- 自由镇
		-- 风暴祭坛
		-- 围攻伯拉勒斯
		[277432] = true,		--- 钢铁箭雨
		[272140] = true,		--- 钢铁弹幕
		-- 托尔达戈
		[258864] = true,		--- 火力压制
		-- 维克雷斯庄园
		[271174] = true,		--- 呕吐
		[265372] = true,		--- 暗影顺劈
		-- 阿塔达萨
		-- 诸王之眠
		-- 暴富矿区
		[263105] = true,		--- 焊枪
		[262066] = true,		--- 充能之爪
		[263583] = true,		--- 横扫千军
		-- 塞塔里斯神庙
		[255741] = true,		--- 顺劈斩
		-- 地渊孢林
		[272457] = true,		--- 震荡波
	}
}