local addonName, addon = ... 

local config = addon.config
local L = addon.language

SLASH_AKI1 = '/aki'
SLASH_AKI2 = '/AKI'
SlashCmdList['AKI'] = function(msg)
    local command, rest = msg:lower():match("^(%S*)%s*(.-)$")
	if command == "cfg" then
		InterfaceOptionsFrame_OpenToCategory("AkiTools")
		InterfaceOptionsFrame_OpenToCategory("AkiTools")

	elseif command == "ad" then
		addon:AnnounceAD(rest)
	
	elseif command == "ads" then
		addon:AnnounceADS(rest)

	elseif command == "adn" then
		addon:AnnounceADN(rest)

	elseif command == "adml" then
		addon:AnnounceADMsgList(rest)

	elseif command=="setpet" then
		config.petID = C_PetJournal.GetSummonedPetGUID()
		print(L["setPet"]..C_PetJournal.GetBattlePetLink(config.petID))
		
	elseif command=="summonp" then
		local p = C_PetJournal.GetSummonedPetGUID()
		if p ~= config.petID then
			C_PetJournal.SummonPetByGUID(config.petID)
		end
	elseif command=="summonrp" then
		C_PetJournal.SummonRandomPet(true)

	elseif command=="ss" then
		addon:SendStats(rest)
		
	elseif command=="rq" then
		addon:QueryAttacking()
		
	elseif command=="setmsg" then
		config.inviteMsg = rest
		print(L["setMsg"].."["..config.inviteMsg.."]")
		
	elseif command=="showmsg" then
		print(L["showMsg"].."["..config.inviteMsg.."]")
		
	elseif command=="help" then
		print(L["help"])
		
	elseif command == "test" then
		print(L["test"])
	end
end